/*
 * Created on 06-jul-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.gvsig.geoprocessing.operations.strategies;

import java.util.BitSet;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.layerOperations.Selectable;
import com.iver.cit.gvsig.fmap.operations.strategies.FeatureVisitor;
import com.iver.cit.gvsig.fmap.operations.strategies.VisitException;
import com.vividsolutions.jts.geom.Geometry;

public class SelectedShapeToJTSVisitor implements FeatureVisitor {
    private BitSet bitSet = null;
    private int selectedIndex;
    private Geometry[] jtsGeometries = null;

    public void visit(IGeometry g, int index) throws VisitException {
        // TODO Auto-generated method stub
        if (bitSet.get(index)){
            jtsGeometries[selectedIndex] = g.toJTSGeometry();
            selectedIndex++;
        }
    }

    public void stop(FLayer layer) {
        // TODO Auto-generated method stub

    }

    public boolean start(FLayer layer) {
        // TODO Auto-generated method stub
        if (layer instanceof Selectable) {
            bitSet = ((Selectable)layer).getSelection();
            selectedIndex = 0;
            jtsGeometries = new Geometry[bitSet.cardinality()];
            return true;
        }
        return false;
    }

    /**
     * @return Returns the jtsGeometries.
     */
    public Geometry[] getJtsGeometries() {
        return jtsGeometries;
    }

}
